
Name:      qubes-mgmt-salt-dom0-virtual-machines
Version:   4.1.15
Release:   1%{?dist}
Summary:   Downloads, installs and configures template as well as creating and configuring virtual-machine AppVM's.
License:   GPL 2.0
URL:	   http://www.qubes-os.org/

Group:     System administration tools
BuildArch: noarch
Requires:  qubes-mgmt-salt
Requires:  qubes-mgmt-salt-dom0
Requires:  qubes-core-admin-addon-whonix
# do not require qubes-core-dom0 directly, but if installed, make sure it's the
# right version
Conflicts: qubes-core-dom0 < 4.0.35

Source0: %{name}-%{version}.tar.gz

%description
Downloads, installs and configures template as well as creating and configuring virtual-machine AppVM's.
Uses pillar data to define default VM names and configuration details.

%prep
%setup -q

%build

%install
make install DESTDIR=%{buildroot} LIBDIR=%{_libdir} BINDIR=%{_bindir} SBINDIR=%{_sbindir} SYSCONFDIR=%{_sysconfdir}

%pre

if [ $1 -ge 2 ] && ! [ -e /srv/formulas/base/virtual-machines-formula/qvm/default-mgmt-dvm.sls ]; then
    touch /var/run/%{name}-default-mgmt-dvm-firstinstall
fi

%post
# Enable Pillar States
qubesctl top.enable qvm pillar=true -l quiet --out quiet > /dev/null || true

# Migrate enabled tops from dom0 to base environment
for top in sys-net sys-firewall sys-whonix anon-whonix personal work untrusted vault sys-usb sys-net-with-usb; do
    if [ -h /srv/salt/_tops/dom0/qvm.$top.top ]; then
        rm -f /srv/salt/_tops/dom0/qvm.$top.top
        qubesctl top.enable qvm.$top -l quiet --out quiet > /dev/null || true
    fi
done

if [ -r /srv/pillar/_tops/dom0/qvm.top ]; then
    rm -f /srv/pillar/_tops/dom0/qvm.top
fi

%posttrans

if [ -e /var/run/%{name}-default-mgmt-dvm-firstinstall ]; then
    # create default-mgmt-dvm on update, see QSB#45
    qubesctl state.sls qvm.default-mgmt-dvm
    rm /var/run/%{name}-default-mgmt-dvm-firstinstall
fi

%files
%defattr(-,root,root)
%doc LICENSE README.md
%attr(750, root, root) %dir /srv/formulas/base/virtual-machines-formula
/srv/formulas/base/virtual-machines-formula/README.md
/srv/formulas/base/virtual-machines-formula/LICENSE
/srv/formulas/base/virtual-machines-formula/qvm/anon-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/anon-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/default-dispvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-dispvm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-guivm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-guivm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-audiovm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-audiovm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-mgmt-dvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/hide-usb-from-dom0.sls
/srv/formulas/base/virtual-machines-formula/qvm/personal.sls
/srv/formulas/base/virtual-machines-formula/qvm/personal.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-template.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu-attach-gpu.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu-detach-gpu.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-gpu.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vnc-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vnc.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-gui-vnc.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio-template.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio-vm.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-audio.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-firewall.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-firewall.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-net.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-net.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-usb.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-usb.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/template.jinja
/srv/formulas/base/virtual-machines-formula/qvm/template-gui.jinja
/srv/formulas/base/virtual-machines-formula/qvm/template-whonix-gw.sls
/srv/formulas/base/virtual-machines-formula/qvm/template-whonix-ws.sls
/srv/formulas/base/virtual-machines-formula/qvm/untrusted.sls
/srv/formulas/base/virtual-machines-formula/qvm/untrusted.top
/srv/formulas/base/virtual-machines-formula/qvm/updates-via-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/updates-via-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/usb-keyboard.sls
/srv/formulas/base/virtual-machines-formula/qvm/usb-keyboard.top
/srv/formulas/base/virtual-machines-formula/qvm/vault.sls
/srv/formulas/base/virtual-machines-formula/qvm/vault.top
/srv/formulas/base/virtual-machines-formula/qvm/whonix.jinja
/srv/formulas/base/virtual-machines-formula/qvm/whonix-ws-dvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/work.sls
/srv/formulas/base/virtual-machines-formula/qvm/work.top

%attr(750, root, root) %dir /srv/pillar/base/qvm
%config(noreplace) /srv/pillar/base/qvm/init.sls
%config(noreplace) /srv/pillar/base/qvm/sys-net-as-usbvm.sls
%config(noreplace) /srv/pillar/base/qvm/sys-net-as-usbvm.top
%config(noreplace) /srv/pillar/base/qvm/whonix-testing.sls
%config(noreplace) /srv/pillar/base/qvm/whonix-testing.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-as-audiovm.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-as-audiovm.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui-gpu.top
%config(noreplace) /srv/pillar/base/qvm/sys-gui-gpu.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-vnc.sls
%config(noreplace) /srv/pillar/base/qvm/sys-gui-vnc.top
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-net.sls
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-net.top
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-firewall.sls
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-firewall.top
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-usb.sls
%config(noreplace) /srv/pillar/base/qvm/disposable-sys-usb.top
/srv/pillar/base/qvm/init.top

%config(noreplace) /etc/salt/minion.d/formula-virtual-machines.conf

%changelog
* Fri Oct 08 2021 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-mgmt-salt-dom0-virtual-machines.git

* Fri Oct 08 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4af39b4
- version 4.1.15

* Thu Sep 30 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - aea9e37
- Use qvm.template_installed for installing template for sys-gui too

* Thu Sep 16 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1f942d4
- version 4.1.14

* Thu Sep 16 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ed1278
- Use new qvm.template_installed state

* Sat Sep 11 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a874036
- Install qubes-input-proxy-sender for sys-gui-gpu support

* Sat Sep 11 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 934d452
- version 4.1.13

* Wed Sep 08 2021 Patrick Schleizer <adrelanos@whonix.org> - 7b70b78
- Whonix 16

* Wed Sep 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ee7f9ad
- version 4.1.12

* Thu Aug 19 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f9a76ff
- Enable xscreensaver in Xfce for sys-gui

* Mon Jul 26 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - af23ff0
- sys-gui: drop orphaned xfwm4-theme-nodoka

* Sat Jul 10 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3f1f727
- Switch to fedora-34-xfce as default template for audio/gui

* Wed Jun 23 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 6314acb
- Add VNC GuiVM

* Thu Jun 17 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 56fc1ff
- version 4.1.11

* Sun May 30 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1d20b65
- Do not disable xscreensaver in sys-gui

* Sat May 29 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 67e78e5
- Set up policies for clipboard copy and paste

* Tue May 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - edb5394
- sys-gui: do not intercept copy/paste key combos at dom0, let sys-gui see them

* Fri May 21 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e7faff1
- Set a generic 'guivm' and 'audiovm' qvm-service

* Thu May 20 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99098db
- Include qubes widgets package (qubes-desktop-linux-manager) in GUIVM

* Tue May 04 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 79e9b2b
- Explicitly order sys-usb before user login

* Thu Feb 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b75e6c2
- version 4.1.10

* Wed Feb 24 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9dbe0d1
- Switch template for sys-gui and sys-audio to fedora-33(-xfce) too

* Sun Feb 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c5e5559
- version 4.1.9

* Sat Feb 13 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 050dcc0
- Switch default template to fedora-33

* Sun Nov 15 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 86178b6
- Add .gitlab-ci.yml

* Tue Oct 13 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 62c888b
- version 4.1.8

* Tue Oct 13 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ba165b
- Adjust for dummy-psu packages name change

* Sat Oct 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2f18114
- version 4.1.7

* Wed Oct 07 2020 herypt <70331266+herypt@users.noreply.github.com> - 4eb225c
- Support creation of disposable servicevms

* Sat Sep 26 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - c3e00fd
- sys-gui-gpu: setup sys-usb to sys-gui-gpu mouse RPC policy

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 094c1e3
- sys-gui-gpu: rename feature for input dom0 devices

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 1b3417b
- sys-gui-gpu: use salt for getting first dom0 user

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - c7a00c3
- sys-gui-gpu: get first dom0 user of 'qubes' group

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 1fbbeaf
- sys-gui-gpu: read password hash from dom0 set user

* Sat Sep 19 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 6f53379
- sys-gui-gpu: set TARGET_DOMAIN for input-proxy-sender service

* Mon Aug 31 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 8e34481
- sys-gui-gpu: trigger input dom0 ps2 devices

* Mon Aug 31 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - b486be7
- sys-gui: support for dummy psu and backlight

* Thu Aug 06 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d841019
- version 4.1.6

* Mon Aug 03 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6cec852
- sys-gui: enable fullscreen and add xsession entry

* Fri Jun 19 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3c6cdc1
- Update default template of sys-gui-gpu to fedora-32-xfce

* Thu Jun 18 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 50a8c94
- sys-gui-template: handle debian and update global list

* Wed Jun 17 2020 Artur Puzio <contact@puzio.waw.pl> - e69f260
- Added sys-gui-gpu states

* Fri Jun 12 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - df46b8f
- version 4.1.5

* Fri Jun 12 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 10c82f5
- Allow GUI domain to set the keyboard layout

* Sun Jun 07 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5d5752d
- Fix Admin API policy for GUI VM

* Wed Jun 03 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7f92ff6
- gui: sync xfce packages

* Thu May 28 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5d2f9db
- Switch sys-gui and sys-audio to fedora-32-xfce template

* Sun May 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0ad47d9
- version 4.1.4

* Thu May 21 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1a8ab02
- Use 50-* policy files for salt-managed policy

* Thu May 21 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d0f18bc
- Use 50-* policy files for salt-managed policy

* Mon May 18 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6eb334b
- Add other necessary calls into sys-gui's policy

